<template>
  <section class="grid grid-cols-12 gap-4 xl:gap-6">
    <Container class="col-span-12 md:col-span-6 xl:col-span-3">
      <SectionHeader icon="mdi-progress-check">
        Статус
      </SectionHeader>

      <BookingStatusDisplay
        :editable="[BookingStatus.BOOKED, BookingStatus.ACTIVE].includes(booking.status)"
        :value="booking.status"
        size="large"
        @update="status => $emit('update:status', status)"
      />
    </Container>

    <Container class="col-span-12 md:col-span-6 xl:col-span-3">
      <SectionHeader icon="mdi-cash-plus">
        Прибыль
      </SectionHeader>

      <ProfitDisplay
        mode="display"
        :value="booking.totalProfit"
      />
    </Container>

    <Container class="col-span-12 md:col-span-6 xl:col-span-3">
      <SectionHeader icon="mdi-home-lock">
        Объект
      </SectionHeader>

      <section class="flex items-center gap-2">
        <section
          class="w-4 h-4 rounded-full shrink-0"
          :style="{ backgroundColor: booking.property.color }"
        />

        <section
          v-tooltip="{ text: booking.property.name, openOnClick: true }"
          class="text-lg truncate max-w-full"
        >
          {{ booking.property.name }}
        </section>
      </section>
    </Container>

    <Container class="col-span-12 md:col-span-6 xl:col-span-3">
      <SectionHeader icon="mdi-weather-night">
        Длительность
      </SectionHeader>

      <section class="flex items-center gap-1 text-xl">
        <span class="font-bold">
          {{ nightsCount }}
        </span>

        <span class="text-gray-500">
          {{ getNightsLabel(nightsCount) }}
        </span>
      </section>
    </Container>
  </section>
</template>

<script setup lang="ts">
import { computed } from 'vue';

import { getNightsCount, getNightsLabel } from '@/utils';
import { BookingStatus } from '@/declarations';

import Container from '@/components/layout/Container.vue';
import ProfitDisplay from '@/components/content/ProfitDisplay.vue';
import BookingStatusDisplay from '@/components/content/BookingStatusDisplay.vue';
import SectionHeader from '@/components/layout/SectionHeader.vue';

const props = defineProps<{ booking: IVerboseBooking }>();
defineEmits(['update:status']);

const nightsCount = computed(() => {
  return getNightsCount(props.booking.startDate, props.booking.endDate);
});
</script>